﻿function layer_msg(msg, time) {
    var t = time || 2;
    layer.closeAll();
    layer.open({
        content: msg,
        shade: false,
        style: 'border:none; background-color:#999; color:#fff;',
        time: t, //2秒后自动关闭
    });
}

function highlight(str, keys) {
    keys.forEach(function (key) {
        if (key.trim() != "") {
            var tagLength = "<span class='red'></span>".length;
            var strLower = str.toLowerCase();
            var keyLower = key.toLowerCase();
            var index = 0;
            while (true) {
                index = strLower.indexOf(keyLower, index);
                if (index != -1) {
                    var check = checkRecord(strLower, index);
                    if (check.status) {
                        str = str.substring(0, index) + "<span class='red'>" + str.substring(index, index + key.length) +
                            "</span>" + str.substring(index + key.length);
                        strLower = strLower.substring(0, index) + "<span class='red'>" + strLower.substring(index, index + key.length) +
                            "</span>" + strLower.substring(index + key.length);
                        index = index + tagLength + key.length;
                    } else {
                        index = check.index;
                    }
                } else {
                    break;
                }
            }
        }
    });
    return str;

    function checkRecord(str, index) {
        var result = {
            status: true
        };
        result.index = str.indexOf(">", index);
        if (result.index != -1 && result.index - index < 18) {
            result.status = false;
        }
        return result;
    }
}

function stringCut(str, length) {
    if (str.length > length) return str.substring(0, length) + "...";
    else return str;
}

function GetQueryString0(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
    var r = window.location.search.substr(1).match(reg);
    if (r != null) return r[2]; return null;
}

function getIsinWXMINI(cc) { //是否在微信小程序中
    var u = navigator.userAgent;
    if (u.toLowerCase().indexOf('micromessenger') != -1) {
        wx && (wx.miniProgram.getEnv(function (res) {
            if (res.miniprogram) {//在小程序中
                cc && cc(true);
            } else {
                cc && cc(false);
            }//在微信中
        }));
    } else {
        cc && cc(false);
    }
}
function callAppMethod(name, params) {
    var pageWindow = getPageWindow();
    if (pageWindow == "1") {
        var paramsStr = "";
        if (params) {
            for (var i = 0; i < params.length; i++) {
                paramsStr += '/&' + EncodeUtf8(params[i]);
            }
        }
        var script = "objc://" + name + paramsStr;
        console.log("IOS:"+script);
        //alert("postMessage:"+script);
        window.webkit.messageHandlers.currentCookies.postMessage(script);
    } else if (pageWindow == "2") {
        var paramsStr = "";
        if (params) {
            for (var i = 0; i < params.length; i++) {
                if (i != 0) paramsStr += ",";
                paramsStr += "'" + replace(params[i], "'", "\\'") + "'";
            }
        }
        var script = "window.AndroidJS." + name + "(" + paramsStr + ")";
        //alert( script);
        console.log(script);
        eval(script);
    } else { }

}
function getPageWindow() {
    var u = navigator.userAgent,
        app = navigator.appVersion;
    var type = 0;
    if (!!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) {
        type = 1;
    } else if (u.indexOf('iPhone') > -1) {
        type = 1;
    } else if (u.indexOf('iPad') > -1) {
        type = 1;
    } else if (u.indexOf('Android') > -1 || u.indexOf('Linux') > -1) {
        type = 2;
    }
    return type;
}

function replace(str, s1, s2) {
    var strResult = "";
    try {
        strResult = str.replace(new RegExp(s1, "gm"), s2);
    } catch (e1) {
        try {
            strResult = str.replace(eval("/\\" + s1 + "/g"), s2);
        } catch (e2) {
            strResult = str;
        }
    }
    return strResult;
}

// 字符串转换utf-8
function EncodeUtf8(s1) {
    // escape函数用于对除英文字母外的字符进行编码。如“Visit W3School!”->"Visit%20W3School%21"
    var s = escape(s1);
    var sa = s.split("%"); //sa[1]=u6211
    var retV = "";
    if (sa[0] != "") {
        retV = sa[0];
    }
    for (var i = 1; i < sa.length; i++) {
        if (sa[i].substring(0, 1) == "u") {
            retV += Hex2Utf8(Str2Hex(sa[i].substring(1, 5)));
            if (sa[i].length >= 6) {
                retV += sa[i].substring(5);
            }
        } else retV += "%" + sa[i];
    }
    return retV;
}

function Str2Hex(s) {
    var c = "";
    var n;
    var ss = "0123456789ABCDEF";
    var digS = "";
    for (var i = 0; i < s.length; i++) {
        c = s.charAt(i);
        n = ss.indexOf(c);
        digS += Dec2Dig(eval(n));

    }
    return digS;
}

function Dec2Dig(n1) {
    var s = "";
    var n2 = 0;
    for (var i = 0; i < 4; i++) {
        n2 = Math.pow(2, 3 - i);
        if (n1 >= n2) {
            s += '1';
            n1 = n1 - n2;
        } else
            s += '0';

    }
    return s;

}

function Dig2Dec(s) {
    var retV = 0;
    if (s.length == 4) {
        for (var i = 0; i < 4; i++) {
            retV += eval(s.charAt(i)) * Math.pow(2, 3 - i);
        }
        return retV;
    }
    return -1;
}

function Hex2Utf8(s) {
    var retS = "";
    var tempS = "";
    var ss = "";
    if (s.length == 16) {
        tempS = "1110" + s.substring(0, 4);
        tempS += "10" + s.substring(4, 10);
        tempS += "10" + s.substring(10, 16);
        var sss = "0123456789ABCDEF";
        for (var i = 0; i < 3; i++) {
            retS += "%";
            ss = tempS.substring(i * 8, (eval(i) + 1) * 8);



            retS += sss.charAt(Dig2Dec(ss.substring(0, 4)));
            retS += sss.charAt(Dig2Dec(ss.substring(4, 8)));
        }
        return retS;
    }
    return "";
}

function Base64() {

    // private property
    _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

    // public method for encoding
    this.encode = function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;
        input = _utf8_encode(input);
        while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;
            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }
            output = output +
                _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
                _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
        }
        return output;
    };

    // public method for decoding
    this.decode = function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while (i < input.length) {
            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));
            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;
            output = output + String.fromCharCode(chr1);
            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }
        }
        output = _utf8_decode(output);
        return output;
    };

    // private method for UTF-8 encoding
    _utf8_encode = function (string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            } else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            } else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }
        return utftext;
    };

    // private method for UTF-8 decoding
    _utf8_decode = function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
        while (i < utftext.length) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            } else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            } else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    };
}

function localOpenPreview(item) {//, openType openType 1 本地缓存 2 本地看图
    //encodeURIComponent
    var params = [];
    var urlParams = "name=" + encodeURIComponent(item.modelName) + "&url=" + encodeURIComponent(location.origin + location.pathname);
    var viewerPage = "";
    if (item.type == 1) { //3d 对应路径为目录
        var modelSetting = item.param;
        var urlParamSetting = {
            measure: modelSetting.isShowMeasure,
            PMI: modelSetting.isShowPMI,
            tree: modelSetting.isShowStructureTree,
            treeProperty: modelSetting.isShowStructureTreeProperty
        };
        urlParamSetting = JSON.stringify(urlParamSetting);
        urlParams += "&muit=" + encodeURIComponent(item.mutiConfig);
        urlParams += "&setting=" + encodeURIComponent(urlParamSetting);
        viewerPage += "3DViewer/"+item.pageName+"?" + urlParams + "&path=" + encodeURIComponent(item.path); ///3D Viewer/
    } else if (item.type == 2) { //2d
        if (item.mutiConfig == 1)
            viewerPage += "2DViewer/app_cache.html?t=picAll&" + urlParams + "&path=" + encodeURIComponent(item.path); ///2D Viewer/
        else
            viewerPage += "2DViewer/app_cache.html?t=pdf&" + urlParams + "&path=" + encodeURIComponent(item.path + '/' + item.filename);
    } else if (item.type == 3) { //img
        viewerPage += "imageViewer/app_cache.html?" + urlParams + "&path=" + encodeURIComponent(item.path + '/' + item.filename); ///img Viewer/
    } else if (item.type == 4) { //pdf
        var ser="";
        if (item.mutiConfig == 1){
            ser="&path=" + encodeURIComponent(item.path) +"&t=1";
        }else{
            ser="&path=" + encodeURIComponent(item.path+ '/' + 'preview.pdf'); // app中老逻辑没有处理解压后对文件进行重命名, 暂时在
            // ser="&path=" + encodeURIComponent(item.path+ '/' + item.filename);
        }
        viewerPage += "pdfViewer/app_cache.html?" + urlParams +ser;  ///PDF Viewer/
    }

    //name= &path= &muit= &setting=
    //type 1  3Dviewer 2 2Dviewer 3图片 4 pdfViewer
    // version 指定显示版本，若为空则显示最高版本viewer
    // pageName 需要显示的页面地址（包含各种参数） 

    params.push(item.type);  //1  3Dviewer 2 2Dviewer 3图片 4 pdfViewer
    params.push('');         // version 指定显示版本，若为空则显示最高版本viewer
    params.push(viewerPage); //pageName 需要显示的页面地址（包含各种参数）

    //if (openType == 1) {//1 本地缓存
    callAppMethod("showViewer", params);
    //    //showCacheViewer(type,version,pageName)
    //} else if (openType == 2) {//2 本地看图
    //    callAppMethod("showLocalFileViewer", params);
    //    //showLocalFileViewer(type,version,pageName)
    //}

}

AndroidPageBack = function () {
		try {
			var el = document.querySelector(".top-icoBack");
			if (el) {
				console.log("AndroidPageBack click()");
				el.click();
			} else {
				// history.back(-1);
				console.log("AndroidPageBack goToHomePage()");
				window.AndroidJS.goToHomePage();//返回首页
			}
		} catch (error) {

		}
	};

document.ready = function (callback) {
    ///兼容FF,Google
    if (document.addEventListener) {
        document.addEventListener('DOMContentLoaded', function () {
            document.removeEventListener('DOMContentLoaded', arguments.callee, false);
            callback();
        }, false);
    }
    //兼容IE
    else if (document.attachEvent) {
        document.attachEvent('onreadystatechange', function () {
            if (document.readyState == "complete") {
                document.detachEvent("onreadystatechange", arguments.callee);
                callback();
            }
        });
    }
    else if (document.lastChild == document.body) {
        callback();
    }
};

document.ready(function () {
    // var script = document.createElement('script');
    // script.src = "js/eruda.min.js";
    // document.body.appendChild(script);
    // script.onload = function () {
    //     eruda.init();
    // }
});